<?php
/**
 * Defines the Forms page type
 */

class Forms extends Page {

	function getCMSFields() {
		$fields = parent::getCMSFields();

		$fields->addFieldToTab("Root.Content.Einstellungen", new TextField('Mailto', 'Send to'));
		$fields->addFieldToTab("Root.Content.Einstellungen", new TextField('SubmitText', 'Text after submission'));

		return $fields;
	}
	
	static $db = array(
		'Mailto' => 'Varchar(100)',
		'SubmitText' => 'Text'
	);
	
	static $has_one = array(
	);
}


class Forms_Controller extends Page_Controller {

	function init() {
		parent::init();
	}

	function RegisterForm() {
		/* First get the workshop params */
		$workshopID = (int)$this->urlParams['Action'];
		$workshop = "";
		$workshop = DataObject::get_by_id('Workshop', $workshopID);

		/* Get the date / time from this workshop */
		$datetime = "";
		$datetime = DataObject::get_one('WorkshopDateTime', 'WorkshopID = ' . $workshopID);
		$datestart = CalendarUtil::getDateString($datetime->StartDate,$datetime->EndDate);

		/* Get the locations from this workshop */
		$locations = DataObject::get('CoursePlace', 'WorkshopDateTimeID = ' .$datetime->ID, '',
									'LEFT JOIN WorkshopDateTime_Locations ON CoursePlaceID = CoursePlace.ID');
		if($locations) {
			foreach($locations as $location) {
				$city = $location->City;
				$address = $location->Address;
				$building = $location->Building;
			}
		}

		/* The form itself */
		$fields = new FieldSet(
			new HeaderField ('Registration','1'),
			new FieldGroup(
				new TextField('CourseTitle', 'Coursetitle *', $workshop->Title),
				new TextField('CourseNumber', 'Coursenumber', $workshop->MenuTitle)
			),
			new FieldGroup(
				new TextField('CourseTime', 'Time / Date / Location', $datestart['0'] .' / '. $city .', '. $address. ' ('. $building. ')')
			),
			new LiteralField("CoursePayment","<p class='tip'>
				Any text goes here.....</p>"),
			new LiteralField("CourseDebiting","<p class='tip'>
				Any text goes here... <sup>1</sup></p>"),
			new FieldGroup(
				new TextField('CoursePrice', 'Price &euro;', $workshop->Price),
			),
			new LiteralField("RegisterDate","<p class='signdatetoday'>" . date('j. M. Y') . "</p>
				<p class='signdate'>Date</p>"),
			new HeaderField ('Sender','3'),
			new FieldGroup(
				new TextField('Fullname', 'Surname, Name *'),
				new TextField('Address', 'Address<br>(ZIP - City - Street - Number)'),
				new DateField('Birthday', 'Day of birth'),
				new TextField('PrivatFon', 'Phone'),
				new TextField('Fax', 'Fax'),
				new EmailField('Email', 'E-Mail *')
			)
		);
	
		/* Actions send or print */
		$actions = new FieldSet(
			new FormAction('SendRegisterForm', 'send'),
			new FormAction('PrintRegisterForm', 'print')
		);
		
		$validator = new RequiredFields('CourseTitle', 'Fullname', 'Email');
		
		return new Form($this, 'RegisterForm', $fields, $actions, $validator);
	}

	/* Function to send the reigster form */
	function SendRegisterForm($data) {

       /* send email to */
		$From = $data['Email'];
		$To = $this->Mailto;
		$Subject = 'Coursetitle: ' . $data['CourseTitle'];
		$email = new Email($From, $To, $Subject);
		$email->setTemplate('RegisterEmail');
		$email->populateTemplate($data);
		$email->send();

		/* send a copy to the registrar */
		$From = $this->Mailto;
		$To = $data['Email'];
		$Subject = 'Coursetitle: ' . $data['CourseTitle'];
		$email = new Email($From, $To, $Subject);
		$email->setTemplate('RegisterEmailCopy');
		$email->populateTemplate($data);
		$email->send();
		Director::redirect(Director::baseURL(). $this->URLSegment . "/?success=1");

	}

	/* Function to print the register form */
	function PrintRegisterForm($data) {
      
		$Subject = 
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >
<head>
<style type="text/css">
body, html {
	background:#FFF;
	font: 0.9em Verdana, Tahoma, sans-serif;
	width: 80%;
	color:#000;
	}
body {
	border: 1px dashed #000;
	}
h2.register {
	font: 1.1em Verdana, Tahoma, sans-serif bold;
	color: #4EA3D7; 
	margin-left: 25px;
	margin-right: 100px;
	background: #E9E9E9;
	}
p {
	font-family: Verdana, Tahoma, sans-serif;
	font-size: 0.9em;
	margin-left: 25px;
	margin-right: 25px;
	background: #E9E9E9;
	}
p.printbutton,
p.backbutton {
	text-decoration: none;
	width: 50%;
	text-align: center;
	}
</style>
</head>
<body>
<p class="printbutton"><a href="javascript:window.print()">Print</a></p><br>
<h2 class="register">Print your Registration</h2><br>
<p>Coursetitle: ' . $data['CourseTitle'] . '</p>
<p>Coursenumber: ' . $data['CourseNumber'] . '</p>
<p>Time / Location: ' . $data['CourseTime'] . '</p>
<p>Price: ' . $data['CoursePrice'] . '</p>
<p>Name: ' . $data['Fullname'] . '</p>
<p>Address: ' . $data['Address'] . '</p>
<p>Phone: ' . $data['PrivatFon'] . ' </p>
<p>Fax: ' . $data['Fax'] . '</p>
<p>E-Mail: ' . $data['Email'] . '</p>
<p>Birthday: ' . $data['Birthday'] . '</p><br>
<p class="backbutton"><a href="javascript:history.back(-1)">Back to the registration form</a></p>
</body>
</html>';
		$registration = new Email($From, $Subject);

		$registration->setTemplate('PrintRegisterEmail');

		$registration->populateTemplate($data);

		return $registration = <<<HTML
$Subject
HTML
;

		Director::redirectBack;
	}
/* Register Form end */
}

?>
